# Copyright (c) Meta Platforms, Inc. and affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

# pyre-strict
from typing import Any, Dict, List, Sequence, Tuple

class ExecuTorchModule:
    # pyre-ignore[2, 3]: "Any" in parameter and return type annotations.
    def __call__(self, inputs: Any) -> List[Any]: ...
    # pyre-ignore[2, 3]: "Any" in parameter and return type annotations.
    def run_method(self, method_name: str, inputs: Sequence[Any]) -> List[Any]: ...
    # pyre-ignore[2, 3]: "Any" in parameter and return type annotations.
    def forward(self, inputs: Sequence[Any]) -> List[Any]: ...
    # Bundled program methods.
    def load_bundled_input(
        self, bundle: BundledModule, method_name: str, testset_idx: int
    ) -> None: ...
    def verify_result_with_bundled_expected_output(
        self,
        bundle: BundledModule,
        method_name: str,
        testset_idx: int,
        rtol: float = 1e-5,
        atol: float = 1e-8,
    ) -> None: ...
    def has_etdump(self) -> bool: ...
    def write_etdump_result_to_file(self, path: str) -> None: ...

class BundledModule: ...

def _load_for_executorch(
    path: str, enable_etdump: bool = False
) -> ExecuTorchModule: ...
def _load_for_executorch_from_buffer(
    buffer: bytes, enable_etdump: bool = False
) -> ExecuTorchModule: ...
def _load_for_executorch_from_bundled_program(
    module: BundledModule, enable_etdump: bool = False
) -> ExecuTorchModule: ...
def _load_bundled_program_from_buffer(
    buffer: bytes, non_const_pool_size: int = ...
) -> BundledModule: ...
def _get_operator_names() -> List[str]: ...
def _create_profile_block(name: str) -> None: ...
def _dump_profile_results() -> bytes: ...
def _reset_profile_results() -> None: ...
